"use strict";
cc._RF.push(module, 'f9b352jbGtMIqjEuud60Wpx', 'OnTouchCtrl');
// OnTouchCtrl.js

"use strict";

cc.Class({
  "extends": cc.Component,
  properties: {
    canvas: cc.Node,
    helptyp: cc.Node,
    follower: cc.Prefab,
    // follower: {
    //     default: null,
    //     type: cc.Node,
    // },
    followSpeed: 500
  },
  // use this for initialization
  onLoad: function onLoad() {
    var self = cc.instantiate(this.follower);
    self.parent = this.helptyp;
    self.position = cc.v2(0, 0); //var self = this;

    self.moveToPos = cc.v2(0, 0);
    self.isMoving = false;
    self.canvas.on(cc.Node.EventType.TOUCH_START, function (event) {
      var touches = event.getTouches();
      var touchLoc = touches[0].getLocation();
      self.isMoving = true;
      self.moveToPos = self.follower.parent.convertToNodeSpaceAR(touchLoc);
    }, self.node);
    self.canvas.on(cc.Node.EventType.TOUCH_MOVE, function (event) {
      var touches = event.getTouches();
      var touchLoc = touches[0].getLocation();
      self.moveToPos = self.follower.parent.convertToNodeSpaceAR(touchLoc);
    }, self.node);
    self.canvas.on(cc.Node.EventType.TOUCH_END, function (event) {
      self.isMoving = false; // when touch ended, stop moving
    }, self.node);
  },
  // called every frame
  update: function update(dt) {
    //if (!this.isMoving) return;
    var oldPos = this.follower.position; // get move direction

    var direction = this.moveToPos.sub(oldPos).normalize(); // multiply direction with distance to get new position

    var newPos = oldPos.add(direction.mul(this.followSpeed * dt)); // set new position

    this.follower.setPosition(newPos);
  }
});

cc._RF.pop();